searchData={"items":[{"type":"module","title":"MediaCodecs","doc":"Media codecs utilities.","ref":"MediaCodecs.html"},{"type":"module","title":"MediaCodecs.H264","doc":"Utilities for working with H.264 (AVC) video codec.","ref":"MediaCodecs.H264.html"},{"type":"function","title":"MediaCodecs.H264.annexb_to_elementary_stream/2","doc":"Convert an Annex B formatted access unit to an elementary stream.\n\nThe NALU prefix size can be specified, defaulting to 4 bytes.","ref":"MediaCodecs.H264.html#annexb_to_elementary_stream/2"},{"type":"function","title":"MediaCodecs.H264.nalus/1","doc":"Convert an access unit to a list of NALUs.","ref":"MediaCodecs.H264.html#nalus/1"},{"type":"function","title":"MediaCodecs.H264.pop_parameter_sets/1","doc":"Pops parameter sets from access unit.","ref":"MediaCodecs.H264.html#pop_parameter_sets/1"},{"type":"type","title":"MediaCodecs.H264.profile/0","doc":"","ref":"MediaCodecs.H264.html#t:profile/0"},{"type":"module","title":"MediaCodecs.H264.NALU","doc":"Struct describing an h264 nalu.","ref":"MediaCodecs.H264.NALU.html"},{"type":"function","title":"MediaCodecs.H264.NALU.keyframe?/1","doc":"Checks if the NALU is a keyframe (IDR).","ref":"MediaCodecs.H264.NALU.html#keyframe?/1"},{"type":"type","title":"MediaCodecs.H264.NALU.nalu_type/0","doc":"","ref":"MediaCodecs.H264.NALU.html#t:nalu_type/0"},{"type":"function","title":"MediaCodecs.H264.NALU.parse/2","doc":"Parses a NALU bitstring and returns a NALU struct.\n\nAn optional keyword can be provided to completely parse the NAL unit:\n- `:sps` - provide the parsed sps NAL unit. Needed for slice parsing.\n- `:pps` - provide the parsed pps NAL unit. Needed for slice parsing.","ref":"MediaCodecs.H264.NALU.html#parse/2"},{"type":"function","title":"MediaCodecs.H264.NALU.parse_header/1","doc":"Parses the NALU header.","ref":"MediaCodecs.H264.NALU.html#parse_header/1"},{"type":"type","title":"MediaCodecs.H264.NALU.t/0","doc":"","ref":"MediaCodecs.H264.NALU.html#t:t/0"},{"type":"function","title":"MediaCodecs.H264.NALU.type/1","doc":"Gets the NALU type.","ref":"MediaCodecs.H264.NALU.html#type/1"},{"type":"function","title":"MediaCodecs.H264.NALU.vcl?/1","doc":"Checks if the NALU is a Video Coding Layer (VCL) NALU.","ref":"MediaCodecs.H264.NALU.html#vcl?/1"},{"type":"module","title":"MediaCodecs.H264.NALU.PPS","doc":"Struct describing an H.264 Picture Parameter Set (PPS).","ref":"MediaCodecs.H264.NALU.PPS.html"},{"type":"function","title":"MediaCodecs.H264.NALU.PPS.parse/1","doc":"Parses a PPS NALU from a binary string.","ref":"MediaCodecs.H264.NALU.PPS.html#parse/1"},{"type":"type","title":"MediaCodecs.H264.NALU.PPS.t/0","doc":"","ref":"MediaCodecs.H264.NALU.PPS.html#t:t/0"},{"type":"module","title":"MediaCodecs.H264.NALU.SPS","doc":"Struct describing an H.264 Sequence Parameter Set (SPS).","ref":"MediaCodecs.H264.NALU.SPS.html"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.height/1","doc":"Gets the video width","ref":"MediaCodecs.H264.NALU.SPS.html#height/1"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.id/1","doc":"Gets the SPS ID.","ref":"MediaCodecs.H264.NALU.SPS.html#id/1"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.mime_type/2","doc":"Builds the MIME type from the SPS.\n\nThe tag is the first part of the MIME type (e.g. `avc1`).","ref":"MediaCodecs.H264.NALU.SPS.html#mime_type/2"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.parse/1","doc":"Parses a Sequence Parameter Set (SPS) NALU.","ref":"MediaCodecs.H264.NALU.SPS.html#parse/1"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.profile/1","doc":"Gets the encoder profile.","ref":"MediaCodecs.H264.NALU.SPS.html#profile/1"},{"type":"type","title":"MediaCodecs.H264.NALU.SPS.t/0","doc":"","ref":"MediaCodecs.H264.NALU.SPS.html#t:t/0"},{"type":"function","title":"MediaCodecs.H264.NALU.SPS.width/1","doc":"Gets the video width","ref":"MediaCodecs.H264.NALU.SPS.html#width/1"},{"type":"module","title":"MediaCodecs.H264.NALU.Slice","doc":"Struct describing an H.264 Slice.","ref":"MediaCodecs.H264.NALU.Slice.html"},{"type":"function","title":"MediaCodecs.H264.NALU.Slice.parse/3","doc":"Parses a PPS NALU from a binary string.","ref":"MediaCodecs.H264.NALU.Slice.html#parse/3"},{"type":"type","title":"MediaCodecs.H264.NALU.Slice.t/0","doc":"","ref":"MediaCodecs.H264.NALU.Slice.html#t:t/0"},{"type":"module","title":"MediaCodecs.H264.NaluSplitter","doc":"Split a bytestream to a list of nalus.","ref":"MediaCodecs.H264.NaluSplitter.html"},{"type":"function","title":"MediaCodecs.H264.NaluSplitter.flush/1","doc":"Flushes any unprocessed data from the splitter.","ref":"MediaCodecs.H264.NaluSplitter.html#flush/1"},{"type":"type","title":"MediaCodecs.H264.NaluSplitter.input_structure/0","doc":"","ref":"MediaCodecs.H264.NaluSplitter.html#t:input_structure/0"},{"type":"function","title":"MediaCodecs.H264.NaluSplitter.new/1","doc":"Creates a new NaluSplitter.","ref":"MediaCodecs.H264.NaluSplitter.html#new/1"},{"type":"function","title":"Options - MediaCodecs.H264.NaluSplitter.new/1","doc":"- `:input_type` - The type of input data, can be `:annexb`, `:elementary`, or `{:elementary, size}`.\n    Defaults to `:annexb`.","ref":"MediaCodecs.H264.NaluSplitter.html#new/1-options"},{"type":"function","title":"MediaCodecs.H264.NaluSplitter.process/2","doc":"Processes the given data and splits it into nalus.","ref":"MediaCodecs.H264.NaluSplitter.html#process/2"},{"type":"type","title":"MediaCodecs.H264.NaluSplitter.t/0","doc":"","ref":"MediaCodecs.H264.NaluSplitter.html#t:t/0"},{"type":"module","title":"MediaCodecs.H265","doc":"Utilities for working with H.265 (HEVC) video codec.","ref":"MediaCodecs.H265.html"},{"type":"function","title":"MediaCodecs.H265.annexb_to_elementary_stream/2","doc":"Convert an Annex B formatted access unit to an elementary stream.\n\nThe NALU prefix size can be specified, defaulting to 4 bytes.","ref":"MediaCodecs.H265.html#annexb_to_elementary_stream/2"},{"type":"function","title":"MediaCodecs.H265.nalus/1","doc":"Convert an access unit to a list of NALUs.","ref":"MediaCodecs.H265.html#nalus/1"},{"type":"function","title":"MediaCodecs.H265.pop_parameter_sets/1","doc":"Pops parameter sets from access unit.","ref":"MediaCodecs.H265.html#pop_parameter_sets/1"},{"type":"module","title":"MediaCodecs.H265.NALU","doc":"Struct describing an h265 nalu.","ref":"MediaCodecs.H265.NALU.html"},{"type":"function","title":"MediaCodecs.H265.NALU.keyframe?/1","doc":"Checks if the NALU is a keyframe (IRAP NALU).\n\n    iex> MediaCodecs.H265.NALU.keyframe?(%MediaCodecs.H265.NALU{type: :idr_n_lp})\n    true\n\n    iex> MediaCodecs.H265.NALU.keyframe?(%MediaCodecs.H265.NALU{type: :sps})\n    false","ref":"MediaCodecs.H265.NALU.html#keyframe?/1"},{"type":"type","title":"MediaCodecs.H265.NALU.nalu_type/0","doc":"","ref":"MediaCodecs.H265.NALU.html#t:nalu_type/0"},{"type":"function","title":"MediaCodecs.H265.NALU.parse/2","doc":"Parses a NALU bitstring and returns a NALU struct.\n\nAn optional keyword can be provided to completely parse the NAL unit:\n- `:sps` - provide the parsed sps NAL unit. Needed for slice parsing.\n- `:pps` - provide the parsed pps NAL unit. Needed for slice parsing.","ref":"MediaCodecs.H265.NALU.html#parse/2"},{"type":"function","title":"MediaCodecs.H265.NALU.parse_header/1","doc":"Parses the NALU header.","ref":"MediaCodecs.H265.NALU.html#parse_header/1"},{"type":"type","title":"MediaCodecs.H265.NALU.t/0","doc":"","ref":"MediaCodecs.H265.NALU.html#t:t/0"},{"type":"function","title":"MediaCodecs.H265.NALU.type/1","doc":"Gets NALu type.","ref":"MediaCodecs.H265.NALU.html#type/1"},{"type":"function","title":"MediaCodecs.H265.NALU.vcl?/1","doc":"Checks if the NALU is a Video Coding Layer (VCL) NALU.","ref":"MediaCodecs.H265.NALU.html#vcl?/1"},{"type":"module","title":"MediaCodecs.H265.NALU.PPS","doc":"Struct describing an H.265 Picture Parameter Set (PPS).","ref":"MediaCodecs.H265.NALU.PPS.html"},{"type":"function","title":"MediaCodecs.H265.NALU.PPS.parse/1","doc":"Parses a PPS NALU from a binary string.","ref":"MediaCodecs.H265.NALU.PPS.html#parse/1"},{"type":"type","title":"MediaCodecs.H265.NALU.PPS.t/0","doc":"","ref":"MediaCodecs.H265.NALU.PPS.html#t:t/0"},{"type":"module","title":"MediaCodecs.H265.NALU.SPS","doc":"Struct describing an H.265 Sequence Parameter Set (SPS).","ref":"MediaCodecs.H265.NALU.SPS.html"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.height/1","doc":"Gets the height.","ref":"MediaCodecs.H265.NALU.SPS.html#height/1"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.id/1","doc":"Gets the SPS ID.","ref":"MediaCodecs.H265.NALU.SPS.html#id/1"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.mime_type/2","doc":"Builds the MIME type from the SPS.\n\nThe tag is the first part of the MIME type (e.g. `hvc1`).","ref":"MediaCodecs.H265.NALU.SPS.html#mime_type/2"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.parse/1","doc":"Parses a SPS NALU from a binary string.","ref":"MediaCodecs.H265.NALU.SPS.html#parse/1"},{"type":"type","title":"MediaCodecs.H265.NALU.SPS.profile/0","doc":"","ref":"MediaCodecs.H265.NALU.SPS.html#t:profile/0"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.profile/1","doc":"Gets the stream profile.","ref":"MediaCodecs.H265.NALU.SPS.html#profile/1"},{"type":"type","title":"MediaCodecs.H265.NALU.SPS.t/0","doc":"","ref":"MediaCodecs.H265.NALU.SPS.html#t:t/0"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.video_parameter_set_id/1","doc":"Get video parameter set ID from the SPS.","ref":"MediaCodecs.H265.NALU.SPS.html#video_parameter_set_id/1"},{"type":"function","title":"MediaCodecs.H265.NALU.SPS.width/1","doc":"Gets the width.","ref":"MediaCodecs.H265.NALU.SPS.html#width/1"},{"type":"module","title":"MediaCodecs.H265.NALU.SPS.ProfileTierLevel","doc":"Struct describing the Profile Tier Level (PTL) of an H.265 Sequence Parameter Set (SPS).","ref":"MediaCodecs.H265.NALU.SPS.ProfileTierLevel.html"},{"type":"type","title":"MediaCodecs.H265.NALU.SPS.ProfileTierLevel.t/0","doc":"","ref":"MediaCodecs.H265.NALU.SPS.ProfileTierLevel.html#t:t/0"},{"type":"module","title":"MediaCodecs.H265.NALU.Slice","doc":"Struct describing an H.265 slice.","ref":"MediaCodecs.H265.NALU.Slice.html"},{"type":"function","title":"MediaCodecs.H265.NALU.Slice.parse/3","doc":"Parses a PPS NALU from a binary string.","ref":"MediaCodecs.H265.NALU.Slice.html#parse/3"},{"type":"type","title":"MediaCodecs.H265.NALU.Slice.t/0","doc":"","ref":"MediaCodecs.H265.NALU.Slice.html#t:t/0"},{"type":"module","title":"MediaCodecs.H265.NALU.VPS","doc":"Struct describing an H.265 Video Parameter Set (VPS).","ref":"MediaCodecs.H265.NALU.VPS.html"},{"type":"function","title":"MediaCodecs.H265.NALU.VPS.id/1","doc":"Gets the VPS ID.","ref":"MediaCodecs.H265.NALU.VPS.html#id/1"},{"type":"function","title":"MediaCodecs.H265.NALU.VPS.parse/1","doc":"Parses a VPS NALU from a binary string.","ref":"MediaCodecs.H265.NALU.VPS.html#parse/1"},{"type":"type","title":"MediaCodecs.H265.NALU.VPS.t/0","doc":"","ref":"MediaCodecs.H265.NALU.VPS.html#t:t/0"},{"type":"module","title":"MediaCodecs.H265.NaluSplitter","doc":"Split a bytestream to a list of nalus.","ref":"MediaCodecs.H265.NaluSplitter.html"},{"type":"function","title":"MediaCodecs.H265.NaluSplitter.flush/1","doc":"Flushes any unprocessed data from the splitter.","ref":"MediaCodecs.H265.NaluSplitter.html#flush/1"},{"type":"function","title":"MediaCodecs.H265.NaluSplitter.new/1","doc":"Creates a new NaluSplitter.","ref":"MediaCodecs.H265.NaluSplitter.html#new/1"},{"type":"function","title":"Options - MediaCodecs.H265.NaluSplitter.new/1","doc":"- `:input_type` - The type of input data, can be `:annexb`, `:elementary`, or `{:elementary, size}`.\n    Defaults to `:annexb`.","ref":"MediaCodecs.H265.NaluSplitter.html#new/1-options"},{"type":"function","title":"MediaCodecs.H265.NaluSplitter.process/2","doc":"Processes the given data and splits it into nalus.","ref":"MediaCodecs.H265.NaluSplitter.html#process/2"},{"type":"module","title":"MediaCodecs.MPEG4","doc":"MPEG4 utilities.","ref":"MediaCodecs.MPEG4.html"},{"type":"function","title":"MediaCodecs.MPEG4.parse_adts_stream/1","doc":"Parses an ADTS stream into a list of ADTS packets.\n\nThis function returns:\n  * `{:ok, packets, unprocessed}` where `packets` is a list of parsed ADTS packets and `unprocessed` is the remaining unprocessed binary.\n  * `{:error, :invalid_packet}` if an invalid packet is encountered.","ref":"MediaCodecs.MPEG4.html#parse_adts_stream/1"},{"type":"function","title":"MediaCodecs.MPEG4.parse_adts_stream!/1","doc":"Same as `parse_adts_stream/1`, but raises an error if an invalid packet is encountered.","ref":"MediaCodecs.MPEG4.html#parse_adts_stream!/1"},{"type":"function","title":"MediaCodecs.MPEG4.parse_descriptors/1","doc":"Parses the binary into a list of descriptors.\n\nUnknown descritpors are ignored.","ref":"MediaCodecs.MPEG4.html#parse_descriptors/1"},{"type":"module","title":"MediaCodecs.MPEG4.ADTS","doc":"Module for parsing and serializing ADTS (Audio Data Transport Stream) packets.","ref":"MediaCodecs.MPEG4.ADTS.html"},{"type":"function","title":"MediaCodecs.MPEG4.ADTS.parse/1","doc":"Parses an ADTS packet from a binary stream.\n\nThis function returns:\n  * `{:ok, packet, unprocessed}` if the packet is successfully parsed with `unprocessed` as the remaining unprocessed binary.\n  * `:more` if more data is needed to complete the parsing.\n  * `{:error, :invalid_packet}` if the packet is invalid or cannot be parsed.","ref":"MediaCodecs.MPEG4.ADTS.html#parse/1"},{"type":"function","title":"MediaCodecs.MPEG4.ADTS.serialize/1","doc":"Serializes an ADTS packet into a binary.","ref":"MediaCodecs.MPEG4.ADTS.html#serialize/1"},{"type":"type","title":"MediaCodecs.MPEG4.ADTS.t/0","doc":"","ref":"MediaCodecs.MPEG4.ADTS.html#t:t/0"},{"type":"module","title":"MediaCodecs.MPEG4.AudioSpecificConfig","doc":"Module defining the Audio Specific Config for MPEG-4 audio codecs.","ref":"MediaCodecs.MPEG4.AudioSpecificConfig.html"},{"type":"function","title":"MediaCodecs.MPEG4.AudioSpecificConfig.parse/1","doc":"Parses the Audio Specific Config from a binary data.","ref":"MediaCodecs.MPEG4.AudioSpecificConfig.html#parse/1"},{"type":"type","title":"MediaCodecs.MPEG4.AudioSpecificConfig.t/0","doc":"","ref":"MediaCodecs.MPEG4.AudioSpecificConfig.html#t:t/0"},{"type":"module","title":"MediaCodecs.MPEG4.DecoderConfigDescriptor","doc":"Module describing DecoderConfigDescriptor (defined in: ISO/IEC 14496-1)","ref":"MediaCodecs.MPEG4.DecoderConfigDescriptor.html"},{"type":"function","title":"MediaCodecs.MPEG4.DecoderConfigDescriptor.parse/1","doc":"Parses the binary into a DecoderConfigDescriptor struct.","ref":"MediaCodecs.MPEG4.DecoderConfigDescriptor.html#parse/1"},{"type":"function","title":"MediaCodecs.MPEG4.DecoderConfigDescriptor.serialize/1","doc":"Serializes the DecoderConfigDescriptor struct into a binary format.","ref":"MediaCodecs.MPEG4.DecoderConfigDescriptor.html#serialize/1"},{"type":"type","title":"MediaCodecs.MPEG4.DecoderConfigDescriptor.t/0","doc":"","ref":"MediaCodecs.MPEG4.DecoderConfigDescriptor.html#t:t/0"},{"type":"module","title":"MediaCodecs.MPEG4.ESDescriptor","doc":"Module describing ES_Descriptor (defined in: ISO/IEC 14496-1)","ref":"MediaCodecs.MPEG4.ESDescriptor.html"},{"type":"function","title":"MediaCodecs.MPEG4.ESDescriptor.parse/1","doc":"Parses the binary into an ESDescriptor struct.","ref":"MediaCodecs.MPEG4.ESDescriptor.html#parse/1"},{"type":"function","title":"MediaCodecs.MPEG4.ESDescriptor.serialize/1","doc":"","ref":"MediaCodecs.MPEG4.ESDescriptor.html#serialize/1"},{"type":"type","title":"MediaCodecs.MPEG4.ESDescriptor.t/0","doc":"","ref":"MediaCodecs.MPEG4.ESDescriptor.html#t:t/0"},{"type":"module","title":"MediaCodecs.MPEG4.SLConfigDescriptor","doc":"Module describing SLConfigDescriptor (defined in: ISO/IEC 14496-1)","ref":"MediaCodecs.MPEG4.SLConfigDescriptor.html"},{"type":"function","title":"MediaCodecs.MPEG4.SLConfigDescriptor.parse/1","doc":"Parses the binary into a SLConfigDescriptor struct.","ref":"MediaCodecs.MPEG4.SLConfigDescriptor.html#parse/1"},{"type":"function","title":"MediaCodecs.MPEG4.SLConfigDescriptor.serialize/1","doc":"Serializes the SLConfigDescriptor struct into a binary format.","ref":"MediaCodecs.MPEG4.SLConfigDescriptor.html#serialize/1"},{"type":"type","title":"MediaCodecs.MPEG4.SLConfigDescriptor.t/0","doc":"","ref":"MediaCodecs.MPEG4.SLConfigDescriptor.html#t:t/0"},{"type":"module","title":"MediaCodecs.MPEG4.Utils","doc":"Utilities functions","ref":"MediaCodecs.MPEG4.Utils.html"},{"type":"function","title":"MediaCodecs.MPEG4.Utils.channel_config/1","doc":"Returns the channel configuration from channels.","ref":"MediaCodecs.MPEG4.Utils.html#channel_config/1"},{"type":"function","title":"MediaCodecs.MPEG4.Utils.sampling_frequency_from_index/1","doc":"Returns the sampling frequency for a given index.","ref":"MediaCodecs.MPEG4.Utils.html#sampling_frequency_from_index/1"},{"type":"function","title":"MediaCodecs.MPEG4.Utils.sampling_frequency_index/1","doc":"Returns the sampling frequency index for a given sampling frequency.","ref":"MediaCodecs.MPEG4.Utils.html#sampling_frequency_index/1"},{"type":"extras","title":"MediaCodecs","doc":"# MediaCodecs\n\n[![Hex.pm](https://img.shields.io/hexpm/v/media_codecs.svg)](https://hex.pm/packages/media_codecs)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/media_codecs)\n\nMedia codecs utilities.","ref":"readme.html"},{"type":"extras","title":"Installation - MediaCodecs","doc":"The package can be installed by adding `media_codecs` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:media_codecs, \"~> 0.7.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}